-- Copyright (C) 2012 Papavasileiou Dimitris                             
--                                                                      
-- This program is free software: you can redistribute it and/or modify 
-- it under the terms of the GNU General Public License as published by 
-- the Free Software Foundation, either version 3 of the License, or    
-- (at your option) any later version.                                  
--                                                                      
-- This program is distributed in the hope that it will be useful,      
-- but WITHOUT ANY WARRANTY; without even the implied warranty of       
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
-- GNU General Public License for more details.                         
--                                                                      
-- You should have received a copy of the GNU General Public License    
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.

array = require "array-core"

local function pretty(a, prefix)
   if type(a) == "number" then
      return tostring(a)
   else
      local s, m, last, number

      prefix = prefix or ""
      m = #a
      last = a[m]
      number = type(last) == "number"

      s = prefix .. "{"

      if not number then
	 s = s .. "\n"
      end
	 
      for i = 1, m - 1 do
	 s = s .. pretty(a[i], prefix .. "  ") .. ", "

	 if not number then
	    s = s .. "\n"
	 end
      end

      s = s .. pretty(last, prefix .. "  ")

      if not number then
	 s = s .. "\n" .. prefix
      end

      return s .. "}"
   end
end

local function size(a)
   return type(a) == "number" and {} or {#a, unpack(size(a[1]))}
end

array.pretty = pretty
array.size = size